<%@ LANGUAGE = VBScript %>
<%
' $Id: pdfclock.vbs.asp,v 1.4.2.1 2001/05/16 12:25:50 york Exp $
'
' PDFlib client: pdfclock example for ActiveX with Active Server Pages and VBScript
' Requires the PDFlib ActiveX component
'
	Option Explicit

	Dim font
	Dim alpha, tm_hour, tm_min, tm_sec
	Dim oPDF
	Dim buf

	Const RADIUS = 200
	Const MARGIN = 20

	Set oPDF = Server.CreateObject("PDFlib_com.PDF")

	if not isObject(oPDF) Then
		Response.write "Couldn't create PDFlib object!"
		Response.end
	End If

	' Open new PDF file
	oPDF.open_file("")

	oPDF.set_info "Creator", "pdfclock.vbs.asp"
	oPDF.set_info "Author", "Thomas Merz"
	oPDF.set_info "Title", "PDF clock (ActiveX/ASP/VBScript)"

	oPDF.begin_page 2 * (RADIUS + MARGIN), 2 * (RADIUS + MARGIN)

	oPDF.translate RADIUS + MARGIN, RADIUS + MARGIN
	oPDF.setcolor "both", "rgb", 0, 0, 1, 0
	oPDF.save

	' minute strokes
	oPDF.setlinewidth 2
	For alpha = 0 To 359 Step 6
	   oPDF.rotate 6
	   oPDF.moveto RADIUS, 0
	   oPDF.lineto RADIUS-MARGIN/3, 0
	   oPDF.stroke
	Next

	oPDF.restore
	oPDF.save

	' 5 minute strokes
	oPDF.setlinewidth 3
	For alpha = 0 To 359 Step 30
   	   oPDF.rotate 30
	   oPDF.moveto RADIUS, 0
	   oPDF.lineto RADIUS-MARGIN, 0
	   oPDF.stroke
	Next

	tm_hour = Hour(Now)
	tm_min = Minute(Now)
	tm_sec = Second(Now)

	' draw hour hand
	oPDF.save
	oPDF.rotate -((tm_min / 60) + tm_hour - 3) * 30
	oPDF.moveto -RADIUS/10, -RADIUS/20
	oPDF.lineto RADIUS/2, 0
	oPDF.lineto -RADIUS/10, RADIUS/20
	oPDF.closepath
	oPDF.fill
	oPDF.restore

	' draw minute hand
	oPDF.save
	oPDF.rotate -((tm_sec / 60) + tm_min - 15) * 6
	oPDF.moveto -RADIUS/10, -RADIUS/20
	oPDF.lineto RADIUS * 0.8, 0
	oPDF.lineto -RADIUS/10, RADIUS/20
	oPDF.closepath
	oPDF.fill
	oPDF.restore

	' draw second hand
	oPDF.setcolor "both", "rgb", 1, 0, 0, 0
	oPDF.setlinewidth 2
	oPDF.save
	oPDF.rotate -(tm_sec - 15) * 6
	oPDF.moveto -RADIUS/5, 0
	oPDF.lineto RADIUS, 0
	oPDF.stroke
	oPDF.restore

	' draw little circle at center
	oPDF.circle 0, 0, RADIUS/30
	oPDF.fill

	oPDF.restore

	oPDF.end_page
	oPDF.close

	buf = oPDF.get_buffer()

	Response.Expires = 0
	Response.Buffer = true
	Response.ContentType = "application/pdf"
	Response.Addheader "Content-Disposition", "inline; filename=" & "pdfclock.vbs.asp.pdf"
	Response.Addheader "Content-Length", LenB(buf)
	Response.BinaryWrite(buf)
	Response.End()

	Set oPDF = nothing
%>
