<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<!--- PDFlib client: pdfclock example for ColdFusion
      requires the ActiveX component --->

<html>
<head>
	<title>PDFlib ColdFusion sample</title>
</head>

<body>

<CFSET RADIUS=200>
<CFSET MARGIN=20>

<CFOBJECT type="COM" name="oPDF" class="PDFlib_com.PDF" action="CREATE">

<CFSET tmp_file=GetTempFile("C:\\tmp\\", "pdfclock.pdf")>
<CFSET res=oPDF.open_file(tmp_file)>
<CFIF res is -1>
	Couldn't open PDF file!
	<CFABORT/>
</CFIF>

<CFSET oPDF.set_info("Creator", "pdfclock.cfm")>
<CFSET oPDF.set_info("Author", "PDFlib GmbH")>
<CFSET oPDF.set_info("Title", "PDFclock sample (ActiveX/ColdFusion)")>

<CFSET oPDF.begin_page(2 * (RADIUS + MARGIN), 2 * (RADIUS + MARGIN))>

<CFSET oPDF.translate(RADIUS + MARGIN, RADIUS + MARGIN)>
<CFSET oPDF.setcolor("both", "rgb", 0, 0, 1, 0)>
<CFSET oPDF.save()>

<!--- minute strokes --->
<CFSET oPDF.setlinewidth(2)>
<cfloop index="alpha" from="0" to="359" step="6">
   <CFSET oPDF.rotate(6)>
   <CFSET oPDF.moveto(RADIUS, 0)>
   <CFSET oPDF.lineto(RADIUS-MARGIN/3, 0)>
   <CFSET oPDF.stroke()>
</cfloop>

<CFSET oPDF.restore()>
<CFSET oPDF.save()>

<!--- 5 minute strokes --->
<CFSET oPDF.setlinewidth(3)>
<CFLOOP index="alpha" from="0" to="359" step="6">
	<CFSET oPDF.rotate(30)>
	<CFSET oPDF.moveto(RADIUS, 0)>
	<CFSET oPDF.lineto(RADIUS-MARGIN, 0)>
	<CFSET oPDF.stroke()>
</CFLOOP>

<CFSET tm_hour=Hour(Now())>
<CFSET tm_min=Minute(Now())>
<CFSET tm_sec=Second(Now())>

<!--- draw hour hand --->
<CFSET oPDF.save()>
<CFSET oPDF.rotate(-((tm_min / 60) + tm_hour - 3) * 30)>
<CFSET oPDF.moveto(-RADIUS/10, -RADIUS/20)>
<CFSET oPDF.lineto(RADIUS/2, 0)>
<CFSET oPDF.lineto(-RADIUS/10, RADIUS/20)>
<CFSET oPDF.closepath()>
<CFSET oPDF.fill()>
<CFSET oPDF.restore()>

<!--- draw minute hand --->
<CFSET oPDF.save()>
<CFSET oPDF.rotate(-((tm_sec / 60) + tm_min - 15) * 6)>
<CFSET oPDF.moveto(-RADIUS/10, -RADIUS/20)>
<CFSET oPDF.lineto(RADIUS * 0.8, 0)>
<CFSET oPDF.lineto(-RADIUS/10, RADIUS/20)>
<CFSET oPDF.closepath()>
<CFSET oPDF.fill()>
<CFSET oPDF.restore()>

<!--- draw second hand --->
<CFSET oPDF.setcolor("both", "rgb", 1, 0, 0, 0)>
<CFSET oPDF.setlinewidth(2)>
<CFSET oPDF.save()>
<CFSET oPDF.rotate(-(tm_sec - 15) * 6)>
<CFSET oPDF.moveto(-RADIUS/5, 0)>
<CFSET oPDF.lineto(RADIUS, 0)>
<CFSET oPDF.stroke()>
<CFSET oPDF.restore()>

<!--- draw little circle at center --->
<CFSET oPDF.circle(0, 0, RADIUS/30)>
<CFSET oPDF.fill()>

<CFSET oPDF.restore()>

<CFSET oPDF.end_page()>
<CFSET oPDF.close()>

<CFCONTENT TYPE="application/pdf" FILE="#tmp_file#" DELETEFILE="yes">

</body>
</html>
