{
  $Id: pdfclock.pas,v 1.4.2.1 2001/05/16 12:25:50 york Exp $

  PDFlib client: pdfclock example in Delphi.
}

unit pdfclock;

interface

uses Windows, Classes, Forms, Dialogs, ExtCtrls, Controls, StdCtrls,
  OleServer, PDFlib_com_TLB;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    InsertBtn: TButton;
    pdf: TPDF;
    procedure InsertBtnClick(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

uses SysUtils;

{$R *.DFM}

procedure TForm1.InsertBtnClick(Sender: TObject);
const
  RADIUS = 200.0;
  MARGIN = 20.0;
var
  alpha: Integer;
  tm_hour, tm_min, tm_sec, tm_msec: Word;
  MyDate: TDateTime;

begin
  if pdf.open_file('pdfclock.pdf') = -1 then begin
    ShowMessage('Couldnt open pdfclock.pdf!');
    Exit;
  end;

  pdf.set_info('Creator', 'pdfclock.pas');
  pdf.set_info('Author', 'Rainer Schaaf');
  pdf.set_info('Title', 'pdfclock sample (Delphi)');

  pdf.begin_page(2 * (RADIUS + MARGIN), 2 * (RADIUS + MARGIN));
  pdf.translate(RADIUS + MARGIN, RADIUS + MARGIN);
  pdf.setcolor('both', 'rgb', 0.0, 0.0, 1.0, 0.0);
  pdf.save;

  { minute strokes }
  pdf.setlinewidth(2.0);
  alpha := 0;
  while alpha < 360 do begin
    alpha := alpha + 6;
    pdf.rotate(6.0);
    pdf.moveto(RADIUS, 0.0);
    pdf.lineto(RADIUS-MARGIN/3, 0.0);
    pdf.stroke;
  end;

  pdf.restore;
  pdf.save;

  { 5 minute strokes }
  pdf.setlinewidth(3.0);
  alpha := 0;
  while alpha < 360 do begin
      alpha := alpha + 6;
      pdf.rotate(30.0);
      pdf.moveto(RADIUS, 0.0);
      pdf.lineto(RADIUS-MARGIN, 0.0);
      pdf.stroke;
  end;

  MyDate := Now;
  DecodeTime(MyDate, tm_hour, tm_min, tm_sec, tm_msec);

  { draw hour hand }
  pdf.save;
  pdf.rotate(-((tm_min/60.0) + tm_hour - 3.0) * 30.0);
  pdf.moveto(-RADIUS/10, -RADIUS/20);
  pdf.lineto(RADIUS/2, 0.0);
  pdf.lineto(-RADIUS/10, RADIUS/20);
  pdf.closepath;
  pdf.fill;
  pdf.restore;

  { draw minute hand }
  pdf.save;
  pdf.rotate(-((tm_sec/60.0) + tm_min - 15.0) * 6.0);
  pdf.moveto(-RADIUS/10, -RADIUS/20);
  pdf.lineto(RADIUS * 0.8, 0.0);
  pdf.lineto(-RADIUS/10, RADIUS/20);
  pdf.closepath;
  pdf.fill;
  pdf.restore;

  { draw second hand }
  pdf.setcolor('both', 'rgb', 1.0, 0.0, 0.0, 0.0);
  pdf.setlinewidth(2);
  pdf.save;
  pdf.rotate(-((tm_sec - 15.0) * 6.0));
  pdf.moveto(-RADIUS/5, 0.0);
  pdf.lineto(RADIUS, 0.0);
  pdf.stroke;
  pdf.restore;

  { draw little circle at center }
  pdf.circle(0, 0, RADIUS/30);
  pdf.fill;

  pdf.restore;

  pdf.end_page;
  pdf.close;
end;

end.
