{
  $Id: personalize.pas,v 1.5 2001/04/18 10:16:13 tm Exp $

  PDFlib/PDI client: personalization demo
}

unit personalize;

interface

uses Windows, Classes, Forms, Dialogs, ExtCtrls, Controls, StdCtrls,
  OleServer, PDFlib_com_TLB;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    InsertBtn: TButton;
    pdf: TPDF;
    procedure InsertBtnClick(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

uses SysUtils;

{$R *.DFM}

procedure TForm1.InsertBtnClick(Sender: TObject);

  const
    infile = '../../doc/PDFlib-purchase-order.pdf';
    col1 = 70;
    col2 = 335;

  var
    form, page, font: Integer;
    width, height: Real;
    MyDate: TDateTime;
    year, month, day: Word;
    year_s, day_s: String;
    months: array[1..12] of String;

begin
  months[1] := 'January'; months[2] := 'February'; months[3] := 'March';
  months[4] := 'April'; months[5] := 'May'; months[6] := 'June';
  months[7] := 'July'; months[8] := 'August'; months[9] := 'September';
  months[10] := 'October'; months[11] := 'November'; months[12] := 'December';

  if pdf.open_file('personalize.pdf') = -1 then begin
    ShowMessage('Couldn''t open "personalize.pdf"!');
    Exit;
  end;

  pdf.set_info('Creator', 'personalize.pas');
  pdf.set_info('Author', 'Thomas Merz');
  pdf.set_info('Title', 'PDFlib personalization demo (Delphi)');

  form := pdf.open_pdi(infile, '', 0);
  if form = -1 then begin
    ShowMessage('Couldn''t open input file "' + infile + '".');
    Exit
  end;

  page := pdf.open_pdi_page(form, 1, '');
  if page = -1 then begin
    ShowMessage('Couldn''t open page 1 in "' + infile + '".');
    Exit
  end;

  font := pdf.findfont('Helvetica-Bold', 'host', 0);

  { get the dimensions of the imported form }
  width := pdf.get_pdi_value('width', form, page, 0);
  height := pdf.get_pdi_value('height', form, page, 0);

  pdf.begin_page(width, height);
  pdf.place_pdi_page(page, 0, 0, 1, 1);
  pdf.close_pdi_page(page);

  pdf.setfont(font, 18);
  pdf.set_value('leading', 24);
  pdf.set_text_pos(col1, 486);

  pdf.show('Doublecheck, Inc.');
  pdf.continue_text('Petra Porst');
  pdf.continue_text('500, Market St.');
  pdf.continue_text('94110 San Francisco, CA');
  pdf.continue_text('');
  pdf.continue_text('USA');
  pdf.continue_text('+1/950/123-4567');
  pdf.continue_text('+1/950/123-4568');
  pdf.continue_text('');
  pdf.continue_text('petra@doublecheck.com');

  MyDate := Now;
  DecodeDate(MyDate, year, month, day);
  Str(year, year_s);
  Str(day, day_s);
  pdf.set_text_pos(col2, 152);
  pdf.continue_text(months[month] + ' ' + day_s + ', ' + year_s);

  pdf.end_page;
  pdf.close;
  pdf.close_pdi(form);
end;

end.
