{
  $Id: quickreference.pas,v 1.5 2001/04/05 18:55:46 tm Exp $

  PDFlib/PDI client: mini imposition demo
}

unit quickreference;

interface

uses Windows, Classes, Forms, Dialogs, ExtCtrls, Controls, StdCtrls,
  OleServer, PDFlib_com_TLB;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    InsertBtn: TButton;
    pdf: TPDF;
    procedure InsertBtnClick(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

uses SysUtils;

{$R *.DFM}

procedure TForm1.InsertBtnClick(Sender: TObject);

  const
    maxrow = 2;
    maxcol = 2;
    startpage = 108;
    endpage = 111;
    width = 500.0;
    height = 770.0;
    infile = '../../doc/PDFlib-manual-activex.pdf';

  var
    i, manual, page: Integer;
    font, row, col: Integer;
    pageno: Integer;
    pageno_s: String;

begin
  if pdf.open_file('quickreference.pdf') = -1 then begin
    ShowMessage('Couldnt open quickreference.pdf!');
    Exit
  end;

  pdf.set_info('Creator', 'quickreference.pas');
  pdf.set_info('Author', 'Thomas Merz');
  pdf.set_info('Title', 'quickreference sample (Delphi)');

  manual := pdf.open_pdi(infile, '', 0);
  if manual = -1 then begin
    ShowMessage('Couldn''t open input file "' + infile + '"');
    Exit
  end;

  row := 0;
  col := 0;

  for pageno := startpage to endpage do begin
    if (row = 0) and (col = 0) then begin
      pdf.begin_page(width, height);
      font := pdf.findfont('Helvetica-Bold', 'host', 0);
      pdf.setfont(font, 18);
      pdf.set_text_pos(25, height-24);
      pdf.show('PDFlib 4.0 Quick Reference')
    end;

    page := pdf.open_pdi_page(manual, pageno, '');

    if page = -1 then begin
      Str(pageno, pageno_s);
      ShowMessage('Couldn''t open page ' + pageno_s + ' in "' + infile + '"');
      Exit
    end;

    pdf.place_pdi_page(manual, width/maxcol * col,
	    height - (row + 1) * height/maxrow, 1.0/maxrow, 1.0/maxrow);
    pdf.close_pdi_page(page);

    col := col + 1;
    if col = maxcol then begin
      col := 0;
      row := row + 1
    end;
    if row = maxrow then begin
      row := 0;
      pdf.end_page
    end;
  end;

  { finish the last partial page }
  if (row <> 0) or (col <> 0) then
    pdf.end_page;

  pdf.close;
  pdf.close_pdi(manual);
end;

end.
