Attribute VB_Name = "pdfclock"
'
' $Id: pdfclock.bas,v 1.5.2.1 2001/05/16 12:25:50 york Exp $
'
' PDFlib client: pdfclock example in Visual Basic via ActiveX
'
' Important: the PDFlib ActiveX component must be referenced
' via "Project", "References..."!
'

Option Explicit

Sub main()
    Dim ret As Long, font As Long
    Dim alpha As Double, tm_hour As Double, tm_min As Double, tm_sec As Double
    Const RADIUS As Single = 200
    Const MARGIN As Single = 20
    Dim oPDF As PDFlib_com.PDF
	
    Set oPDF = New PDFlib_com.PDF
    
    ' Open new PDF file
    ret = oPDF.open_file("pdfclock.pdf")
    If (ret = -1) Then
        MsgBox "Couldn't open PDF file!"
        End
    End If
    
    oPDF.set_info "Creator", "pdfclock.bas"
    oPDF.set_info "Author", "Thomas Merz"
    oPDF.set_info "Title", "PDF clock (ActiveX/VB)"

    ' start a new page
    oPDF.begin_page 2 * (RADIUS + MARGIN), 2 * (RADIUS + MARGIN)
    oPDF.translate RADIUS + MARGIN, RADIUS + MARGIN
    oPDF.setcolor "both", "rgb", 0, 0, 1, 0
    oPDF.save

    ' minute strokes
    oPDF.setlinewidth 2
    
    For alpha = 0 To 354 Step 6
        oPDF.rotate 6
        oPDF.moveto RADIUS, 0
        oPDF.lineto RADIUS - MARGIN / 3, 0
        oPDF.stroke
    Next alpha

    oPDF.restore
    oPDF.save
    
    ' 5 minute strokes
    oPDF.setlinewidth 3
    For alpha = 0 To 330 Step 30
        oPDF.rotate 30
        oPDF.moveto RADIUS, 0
        oPDF.lineto RADIUS - MARGIN, 0
        oPDF.stroke
    Next alpha

    tm_hour = Hour(Now)
    tm_min = Minute(Now)
    tm_sec = Second(Now)

    ' draw hour hand
    oPDF.save
    oPDF.rotate -((tm_min / 60) + tm_hour - 3) * 30
    oPDF.moveto -RADIUS / 10, -RADIUS / 20
    oPDF.lineto RADIUS / 2, 0#
    oPDF.lineto -RADIUS / 10, RADIUS / 20
    oPDF.closepath
    oPDF.fill
    oPDF.restore

    ' draw minute hand
    oPDF.save
    oPDF.rotate -((tm_sec / 60) + tm_min - 15) * 6
    oPDF.moveto -RADIUS / 10, -RADIUS / 20
    oPDF.lineto RADIUS * 0.8, 0
    oPDF.lineto -RADIUS / 10, RADIUS / 20
    oPDF.closepath
    oPDF.fill
    oPDF.restore

    ' draw second hand
    oPDF.setcolor "both", "rgb", 1, 0, 0, 0
    oPDF.setlinewidth 2
    oPDF.save
    oPDF.rotate -(tm_sec - 15) * 6
    oPDF.moveto -RADIUS / 5, 0
    oPDF.lineto RADIUS, 0
    oPDF.stroke
    oPDF.restore

    ' draw little circle at center -- the brackets work around a bug
    ' in Visual Basic (see manual for details)
    oPDF.[circle] 0, 0, RADIUS / 30
    oPDF.fill
            
    oPDF.restore
    oPDF.end_page             ' finish page
    oPDF.Close                ' close PDF document
    
    Set oPDF = Nothing
    
    End
End Sub
