Attribute VB_Name = "personalize"
'
' $Id: personalize.bas,v 1.8 2001/04/18 10:16:13 tm Exp $
'
' PDFlib client: personalization demo in Visual Basic via ActiveX
'
' Important: the PDFlib ActiveX component must be referenced
' via "Project", "References..."!
'

Option Explicit

Sub main()
    Dim form, page, font
    Dim oPDF As PDFlib_com.PDF
    Dim inFile
    Dim lWidth, lHeight
    Dim col1, col2
    
    Set oPDF = New PDFlib_com.PDF
    
    col1 = 70
    col2 = 335
    
    ' Open new PDF file
    If (oPDF.open_file("personalize.pdf") = -1) Then
        MsgBox "Couldn't open output file!"
        End
    End If
    
    oPDF.set_info "Creator", "personalize.bas"
    oPDF.set_info "Author", "Thomas Merz"
    oPDF.set_info "Title", "PDFlib personalization demo (Active X/VBS)"
    
    inFile = "../../doc/PDFlib-purchase-order.pdf"
    
    form = oPDF.open_pdi(inFile, "", 0)
    If (form = -1) Then
        MsgBox "Couldn't open input file!"
        End
    End If
    
    page = oPDF.open_pdi_page(form, 1, "")
    If (page = -1) Then
        MsgBox "Couldn't open page 1 in input file!"
        End
    End If
    
    font = oPDF.findfont("Helvetica-Bold", "winansi", 0)
    
    ' get the dimensions of the imported form
    lWidth = oPDF.get_pdi_value("width", form, page, 0)
    lHeight = oPDF.get_pdi_value("height", form, page, 0)
    
    ' start a new page
    oPDF.begin_page lWidth, lHeight
    
    oPDF.place_pdi_page page, 0, 0, 1, 1
    oPDF.close_pdi_page page
    
    oPDF.setfont font, 18
    oPDF.set_value "leading", 24
    oPDF.set_text_pos col1, 486
    
    oPDF.Show "Doublecheck, Inc."
    oPDF.continue_text "Petra Porst"
    oPDF.continue_text "500, Market St."
    oPDF.continue_text "94110 San Francisco, CA"
    oPDF.continue_text ""
    oPDF.continue_text "USA"
    oPDF.continue_text "+1/950/123-4567"
    oPDF.continue_text "+1/950/123-4568"
    oPDF.continue_text ""
    oPDF.continue_text "petra@doublecheck.com"
    
    oPDF.set_text_pos col2, 152
    oPDF.continue_text Date
    
    oPDF.end_page
    oPDF.close
    oPDF.close_pdi form
    
    Set oPDF = Nothing
        
End Sub
